Subject: bug#47936: closed (Re: bug#47936: AucTeX and electric-pair-mode)

From: [email-masked] (GNU bug Tracking System)
Date: Wed, 21 Apr 2021 20:10:03 +0000

Your bug report

#47936: AucTeX and electric-pair-mode

which was filed against the auctex package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
47936: http://debbugs.gnu.org/cgi/bugreport.cgi?bug=47936
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: bug#47936: AucTeX and electric-pair-mode
From: Tassilo Horn <[email-masked]>
To: Philip Kaludercic <[email-masked]>
Cc: [email-masked], [email-masked]
Date: Wed, 21 Apr 2021 21:54:57 +0200
List-Id: <debbugs-submit.debbugs.gnu.org>

Philip Kaludercic <[email-masked]> writes:

Hi Philip,

> an annoyance I have with auctex is it's interaction with
> electric-pair-mode. If both LaTeX-electric-left-right-brace and
> electric-pair-mode are enabled, typing '(' inserts "())", because both
> AucTeX and the electric function insert a closing parentheses. I still
> want to keep LaTeX-electric-left-right-brace enabled, because it
> handles TeX-specific parentheses (\{, \left <something>, ...) better.

Ok, makes sense.

> The attached patch would propose a solution that respects
> electric-pair-mode and doesn't insert an extra closing pair if
> enabled.

> @@ -2979,6 +2979,8 @@ is nil, consult user which brace should be used."
>      (if rmacro
>          (insert TeX-esc rmacro))
>      (cond
> +     ((and (string= (char-to-string last-command-event) lbrace)
> +           electric-pair-mode))
>       ((and TeX-arg-right-insert-p rbrace)
>        (insert rbrace))
>       (rmacro

LGTM, I've applied it with slight modifications and a ChangeLog style
commit message following our/Emacs conventions.

Thanks a lot, Philip!

Bye,
Tassilo

Subject: AucTeX and electric-pair-mode
From: Philip Kaludercic <[email-masked]>
To: [email-masked]
Date: Wed, 21 Apr 2021 17:31:10 +0000
List-Id: <debbugs-submit.debbugs.gnu.org>

Hi,

an annoyance I have with auctex is it's interaction with
electric-pair-mode. If both LaTeX-electric-left-right-brace and
electric-pair-mode are enabled, typing '(' inserts "())", because both
AucTeX and the electric function insert a closing parentheses. I still
want to keep LaTeX-electric-left-right-brace enabled, because it handles
TeX-specific parentheses (\{, \left <something>, ...) better.

I'm not sure if there is a real fix for this, but I couldn't find
anything and my go-to solution of locally removing
electric-pair-post-self-insert-function from post-self-insert-hook is
also unstable.

The attached patch would propose a solution that respects
electric-pair-mode and doesn't insert an extra closing pair if
enabled. It seems to work on my system, and if there are no issues it
would be great if something along these lines could be done to avoid
this behaviour.

-- 
	Philip K.

>From d47f68ddf8c7d1d9c90adbc2ea9ee09588010ce3 Mon Sep 17 00:00:00 2001
From: Philip K <[email-masked]>
Date: Wed, 21 Apr 2021 19:25:16 +0200
Subject: [PATCH] Improve handling for parentheses with electric-pair-mode

---
 latex.el | 2 ++
 1 file changed, 2 insertions(+)

diff --git a/latex.el b/latex.el
index 83d50caf..512639d5 100644
--- a/latex.el
+++ b/latex.el
@@ -2979,6 +2979,8 @@ is nil, consult user which brace should be used."
     (if rmacro
         (insert TeX-esc rmacro))
     (cond
+     ((and (string= (char-to-string last-command-event) lbrace)
+           electric-pair-mode))
      ((and TeX-arg-right-insert-p rbrace)
       (insert rbrace))
      (rmacro
-- 
2.30.2